import {diffKeys as $42h8L$diffKeys, DiffStatus as $42h8L$DiffStatus} from "web-utility";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $9d9d42d6bcca2464$exports = {};

$parcel$export($9d9d42d6bcca2464$exports, "VDOMNode", function () { return $9d9d42d6bcca2464$export$c0bc209842f51a46; });
$parcel$export($9d9d42d6bcca2464$exports, "Fragment", function () { return $9d9d42d6bcca2464$export$ffb0004e005737fa; });
class $9d9d42d6bcca2464$export$c0bc209842f51a46 {
    get selector() {
        return $9d9d42d6bcca2464$export$c0bc209842f51a46.selectorOf(this.tagName, this.props?.className);
    }
    static selectorOf(tagName, className) {
        return tagName.toLowerCase() + (className ? `.${className.trim().replace(/\s+/, ".")}` : "");
    }
    static propsMap = {
        className: "class",
        htmlFor: "for"
    };
    static attrsMap = Object.fromEntries(Object.entries(this.propsMap).map((item)=>item.reverse()));
    constructor(node){
        this.node = node;
        if (node instanceof Text) {
            this.text = node.nodeValue;
            return;
        }
        if (!(node instanceof Element)) return;
        const { tagName: tagName , attributes: attributes , style: style , childNodes: childNodes  } = node;
        this.tagName = tagName.toLowerCase();
        const props = Array.from(attributes, ({ name: name , value: value  })=>name !== "style" && [
                $9d9d42d6bcca2464$export$c0bc209842f51a46.attrsMap[name] || name,
                value
            ]).filter(Boolean);
        if (props[0]) this.props = Object.fromEntries(props);
        const styles = Array.from(style, (key)=>[
                key,
                style[key]
            ]);
        if (styles[0]) this.style = Object.fromEntries(styles);
        const children = Array.from(childNodes, (node)=>new $9d9d42d6bcca2464$export$c0bc209842f51a46(node));
        if (children[0]) this.children = children;
    }
}
const $9d9d42d6bcca2464$export$ffb0004e005737fa = ({ style: style , children: children , ...props })=>({
        props: props,
        style: style,
        children: children
    });


var $2982c11f1930d0ea$exports = {};

$parcel$export($2982c11f1930d0ea$exports, "DOMRenderer", function () { return $2982c11f1930d0ea$export$4f0519332fb94dea; });


class $2982c11f1930d0ea$export$4f0519332fb94dea {
    eventPattern = /^on\w+/;
    keyOf = ({ key: key , text: text , props: props , selector: selector  }, index)=>key || props?.id || text || selector && selector + index;
    vNodeOf = (list, key)=>list.find((vNode, index)=>this.keyOf(vNode, index) + "" === key);
    updateProps(node, oldProps = {}, newProps = {}, onDelete, onAdd) {
        const { group: group  } = (0, $42h8L$diffKeys)(Object.keys(oldProps), Object.keys(newProps));
        for (const [key] of group[(0, $42h8L$DiffStatus).Old] || [])onDelete?.(node, key);
        for (const [key] of [
            ...group[(0, $42h8L$DiffStatus).Same] || [],
            ...group[(0, $42h8L$DiffStatus).New] || []
        ])if (oldProps[key] !== newProps[key]) {
            if (onAdd instanceof Function) onAdd(node, key, newProps[key]);
            else Reflect.set(node, key, newProps[key]);
        }
    }
    createNode(vNode) {
        if (vNode.text) return vNode.node = document.createTextNode(vNode.text);
        vNode.node = vNode.tagName ? document.createElement(vNode.tagName) : document.createDocumentFragment();
        return this.patch({
            tagName: vNode.tagName,
            node: vNode.node
        }, vNode).node;
    }
    updateChildren(node, oldList, newList) {
        const { map: map , group: group  } = (0, $42h8L$diffKeys)(oldList.map(this.keyOf), newList.map(this.keyOf));
        for (const [key] of group[(0, $42h8L$DiffStatus).Old] || [])(this.vNodeOf(oldList, key)?.node)?.remove();
        const newNodes = newList.map((vNode, index)=>{
            const key = this.keyOf(vNode, index);
            if (map[key] === (0, $42h8L$DiffStatus).Same) return this.patch(this.vNodeOf(oldList, key), vNode).node;
            return this.createNode(vNode);
        });
        node.append(...newNodes);
    }
    patch(oldVNode, newVNode) {
        this.updateProps(oldVNode.node, oldVNode.props, newVNode.props, (node, key)=>this.eventPattern.test(key) ? node[key.toLowerCase()] = null : node.removeAttribute((0, $9d9d42d6bcca2464$export$c0bc209842f51a46).propsMap[key] || key), (node, key, value)=>node[this.eventPattern.test(key) ? key.toLowerCase() : key] = value);
        this.updateProps(oldVNode.node.style, oldVNode.style, newVNode.style, (node, key)=>node.removeProperty(key));
        this.updateChildren(oldVNode.node, oldVNode.children || [], newVNode.children || []);
        newVNode.node = oldVNode.node;
        return newVNode;
    }
    render(vNode, node = document.body) {
        const root = new (0, $9d9d42d6bcca2464$export$c0bc209842f51a46)(node);
        return this.patch(root, {
            ...root,
            children: [
                vNode
            ]
        });
    }
}




export {$2982c11f1930d0ea$export$4f0519332fb94dea as DOMRenderer, $9d9d42d6bcca2464$export$c0bc209842f51a46 as VDOMNode, $9d9d42d6bcca2464$export$ffb0004e005737fa as Fragment};
//# sourceMappingURL=index.esm.js.map
